;****************************************
;*               SNGDEB                 *
;*             15/07/2004               *
;*         par Marc Plouhinec           *
;*   site: http://www.thebestof.tk      *
;* Email: mailto://m_plouhinec@yahoo.fr *
;*                                      *
;****************************************

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2 
; of the License, or (at your option) any later version.

#Define SNGdebFR

#include "sng10.inc"
 .ORG START_ADDR
 .DB "Debuggeur pour SNG",0

 RES 1,(IY+$0D)
 SET 7,(IY+$14) ;Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD
 RES 2,(IY+$0D) ;Le texte ne dfilera pas si on crit sur la dernire ligne
 LD (premiere_valeur),HL

debut:
 LD A,1
 LD (affiche_adr),A
 LD HL,TEXT_MEM
 LD (pointeur_TEXT_MEM),HL
 LD HL,GRAPH_MEM
 LD DE,GRAPH_MEM+1
 LD (HL),0
 LD BC,767
 LDIR
 LD HL,0
 LD (GRAF_CURS),HL
 LD B,10
 LD HL,(pointeur)
 LD (valeur_initiale),HL
boucle_principale:
 LD HL,(pointeur)
 EX DE,HL
 LD HL,(pointeur_TEXT_MEM)
 LD (HL),E
 INC HL
 LD (HL),D
 LD HL,(pointeur_TEXT_MEM)
 INC HL
 INC HL
 LD (pointeur_TEXT_MEM),HL
 RES 3,(IY+$05) ;Fait en sorte que le texte soit affich noir sur blanc 
 CALL affiche_chaine_dans_GRAPH_MEM
 LD A,10
 CP B
 JR NZ,n_enregistre_pas_1ere_valeur
 LD HL,(pointeur)
 INC HL
 LD (premiere_valeur),HL
n_enregistre_pas_1ere_valeur:
;Calcul_coordonnees
 LD HL,(GRAF_CURS)
 LD A,H
 ADD A,6
 LD H,A
 LD L,0
 LD (GRAF_CURS),HL

 LD HL,(pointeur)
 INC HL
 LD (pointeur),HL

 DJNZ boucle_principale
 CALL GRB_COPY
touches:
 ROM_CALL(GET_KEY)

 CP G_DOWN
 JR NZ,p_bas
 LD A,(curseur)
 CP 9
 JR Z,defile_bas
 INC A
 LD (curseur),A
 LD HL,(valeur_initiale)
 LD (pointeur),HL
 JR debut
defile_bas:
 LD HL,(premiere_valeur)
 LD (pointeur),HL
 JP debut
p_bas:

 CP G_UP
 JR NZ,p_haut
 LD A,(curseur)
 CP 0
 JR Z,defile_haut
 DEC A
 LD (curseur),A
 LD HL,(valeur_initiale)
 LD (pointeur),HL
 JP debut
defile_haut:
 LD HL,(valeur_initiale)
 DEC HL
 LD (pointeur),HL
 JP debut
p_haut:

 CP G_MINUS
 JR NZ,p_moins
 LD HL,(premiere_valeur)
 LD BC,$100
 SBC HL,BC
 LD (pointeur),HL
 JP debut
p_moins:

 CP G_PLUS
 JR NZ,p_plus
 LD HL,(valeur_initiale)
 LD BC,$100
 ADD HL,BC
 LD (pointeur),HL
 JP debut
p_plus:

 CP G_DIV
 JR NZ,p_div
 LD HL,(premiere_valeur)
 LD BC,$1000
 SBC HL,BC
 LD (pointeur),HL
 JP debut
p_div:

 CP G_TIMES
 JR NZ,p_fois
 LD HL,(valeur_initiale)
 LD BC,$1000
 ADD HL,BC
 LD (pointeur),HL
 JP debut
p_fois:

 CP G_ENTER
 JP Z,modif

 CP G_MODE
 JR Z,quit

 JP touches

quit:
 SET 1,(IY+$0D)
 RES 7,(IY+$14) ;Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD
 SET 2,(IY+$0D) ;Le texte ne dfilera pas si on crit sur la dernire ligne
 RES 3,(IY+$05) ;Fait en sorte que le texte soit affich noir sur blanc
 LD HL,(valeur_initiale)
 LD (pointeur),HL
 RET





affiche_chaine_dans_GRAPH_MEM:
 LD A,0
 LD (test_4_octets),A
 LD (test_fd),A
 LD A,(affiche_adr)
 CP 0
 JR Z,continue0
 LD HL,(pointeur)
 CALL HL_HEX
 ROM_CALL(D_ZM_STR)
 LD A,(GRAF_CURS)
 INC A
 INC A
 LD (GRAF_CURS),A
continue0:
 LD HL,(pointeur)
 LD A,(HL)
 PUSH HL
 PUSH BC
 CP $CB ;Si c'est une instruction code sur 2 octets de type: $CBxx
 JR Z,instr_2_octets_cb
 CP $ED ;Si c'est une instruction code sur 2 octets de type: $EDxx
 JR Z,instr_2_octets_ed
 INC HL
 LD A,(HL)
 CP $CB ;Si c'est une instruction code sur 4 octets de type: $CBDD (ou FD) xxxx
 JR Z,instr_4_octets
 DEC HL
 LD A,(HL)
 CP $DD ;Si c'est une instruction code sur 2 octets de type: $DD(ou FD)xx
 JR Z,instr_2_octets_dd_fd
 CP $FD ;Si c'est une instruction code sur 2 octets de type: $DD(ou FD)xx
 JR Z,instr_2_octets_fd

 JR instr_1_octet

instr_2_octets_cb:
 INC HL
 LD (pointeur),HL
 LD A,(HL)
 LD HL,0        ;
 LD L,A         ;
 LD BC,10       ;HL = Chaine
 CALL MUL_HL_BC ;
 LD BC,instr_cb ;
 ADD HL,BC      ;
 LD BC,10
 JP continue1

instr_2_octets_ed:
 INC HL
 LD (pointeur),HL
 LD A,(HL)
 LD B,A
 LD HL,instr_ed
cherche_chaine_ed:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_chaine_ed
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_chaine_ed
retrouve_debut_chaine_ed:
 LD BC,13
 SBC HL,BC
 LD BC,12
 JR continue1

instr_2_octets_fd:
 LD A,1
 LD (test_fd),A
instr_2_octets_dd_fd:
 INC HL
 LD (pointeur),HL
 LD A,(HL)
 LD B,A
 LD HL,instr_dd
cherche_chaine_dd_fd:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_chaine_dd_fd
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_chaine_dd_fd
retrouve_debut_chaine_dd_fd:
 LD BC,16
 SBC HL,BC
 LD BC,15
 JR continue1

instr_1_octet:

 LD HL,0        ;
 LD L,A         ;
 LD BC,13       ;HL = Chaine
 CALL MUL_HL_BC ;
 LD BC,instr    ;
 ADD HL,BC      ;
 LD BC,13
 JR continue1

instr_4_octets:
 DEC HL
 LD A,(HL)
 CP $FD
 JR Z,instr_4_octets_fd
 JR instr_4_octets_dd
instr_4_octets_fd:
 LD A,1
 LD (test_fd),A
instr_4_octets_dd:
 LD BC,instr_cb_dd
 INC HL
 INC HL
 LD (pointeur),HL
 INC HL
 LD A,(HL)
 PUSH BC
 LD HL,0
 LD L,A
 LD BC,6
 SBC HL,BC
 LD A,8
 CALL DIV_HL_A
 LD BC,14
 CALL MUL_HL_BC
 POP BC
 ADD HL,BC         ;HL = Chaine
 LD BC,14
 LD A,1
 LD (test_4_octets),A
 PUSH HL
 LD HL,(pointeur)
 DEC HL
 LD (pointeur),HL
 POP HL

continue1:

;Affiche la chaine dans GRAPH_MEM
recopie_chaine:
 LD A,(HL)
 CP $25 ; $25 = "%"
 JR NZ,continue_recopie
 PUSH HL
 INC HL
 LD A,(HL)
 CP $76 ; $76 = "v"
 JR NZ,deux_octets
 DEC BC
 DEC BC
 PUSH BC
 LD HL,(pointeur)
 INC HL
 LD (pointeur),HL
 LD A,(HL)
 LD HL,0
 LD L,A
 CALL HL_HEX
 INC HL
 INC HL
 LD A,(HL)
 ROM_CALL(M_CHARPUT)
 INC HL
 LD A,(HL)
 ROM_CALL(M_CHARPUT)
 JR continue
deux_octets:
 DEC BC
 DEC BC
 PUSH BC
 LD HL,(pointeur)
 INC HL
 INC HL
 LD (pointeur),HL
 LD A,(HL)
 LD HL,0
 LD L,A
 CALL HL_HEX
 INC HL
 INC HL
 LD A,(HL)
 ROM_CALL(M_CHARPUT)
 INC HL
 LD A,(HL)
 ROM_CALL(M_CHARPUT)
 LD HL,(pointeur)
 DEC HL
 LD A,(HL)
 LD HL,0
 LD L,A
 CALL HL_HEX
 INC HL
 INC HL
 LD A,(HL)
 ROM_CALL(M_CHARPUT)
 INC HL
 LD A,(HL)
 ROM_CALL(M_CHARPUT)
continue:
 POP BC
 POP HL
 INC HL
 INC HL
 LD A,(HL)
continue_recopie:
 CP $58 ; $58 = ="X"
 JR NZ,continue2
 LD A,(test_fd)
 CP 0
 JR NZ,echange_x_y
 LD A,$58 ;$58 = "X"
 JR continue2
echange_x_y:
 LD A,$59 ;$59 = "Y"
continue2:
 PUSH AF
 PUSH BC
 PUSH HL
 LD A,(curseur)
 LD B,A
 LD HL,(GRAF_CURS)
 LD A,H
 LD L,H
 LD H,0
 LD A,6
 CALL DIV_HL_A
 LD A,L
 CP B
 JR Z,texte_blanc_sur_noir
 RES 3,(IY+$05) ;Fait en sorte que le texte soit affich noir sur blanc
 JR continue3
texte_blanc_sur_noir:
 SET 3,(IY+$05)
 LD A,(GRAF_CURS)
 CP $12
 JR NZ,continue3
 LD HL,(pointeur)
 LD (pointeur_curseur),HL
continue3:
 POP HL
 POP BC
 POP AF
 ROM_CALL(M_CHARPUT)
 INC	DE
 INC	HL
 DEC	BC
 LD A,B
 CP 0
 JP NZ,recopie_chaine
 LD A,C
 CP 0
 JP NZ,recopie_chaine

 LD A,(test_4_octets)
 CP 0
 JR Z,instruction_normale
 LD HL,(pointeur)
 INC HL
 LD (pointeur),HL
instruction_normale:

 POP BC
 POP HL
 RET

modif:
 RES 7,(IY+$14)
 RES 3,(IY+$05) ;Fait en sorte que le texte soit affich noir sur blanc
 LD HL,(valeur_initiale)
 LD (pointeur),HL
 LD HL,0
 LD A,(curseur)
 LD L,A
 LD BC,2
 CALL MUL_HL_BC
 EX DE,HL
 LD HL,TEXT_MEM
 ADD HL,DE
 LD E,(HL)
 INC HL
 LD D,(HL)
 EX DE,HL
;ici, HL=adresse de l'instruction
 LD (adresse_instruction),HL
 LD HL,(pointeur)
 LD (pointeur_sav),HL
 ROM_CALL(CLEARLCD)
 LD HL,GRAPH_MEM
 LD DE,GRAPH_MEM+1
 LD (HL),0
 LD BC,767
 LDIR
 PRINTN(0,taille_instr)
 PRINTN(3,octet)
 PRINTN(4,mot)
 PRINTN(5,dmot)
attend_touche_modif:
 ROM_CALL(GET_KEY)
 CP 0
 JR Z,attend_touche_modif
 CP G_1
 JP Z,unoctet
 CP G_2
 JP Z,deuxoctets
 CP G_3
 JP Z,quatreoctets

retourne_debut:
 LD A,0
 LD (test_fd),A
 LD HL,(pointeur_sav)
 LD (pointeur),HL
 SET 7,(IY+$14) ;Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD
 JP debut

unoctet:
 LD A,(curseur)
 LD (curseur_sav),A
 LD A,0
 LD (affiche_adr),A
 LD HL,0
 LD (TEXT_MEM+$14),HL
 LD (TEXT_MEM+$16),HL
 LD A,$FF
 LD (TEXT_MEM+$14),A
recommence_un_octet:
 ROM_CALL(CLEARLCD)
 PRINTN(0,choix_instr_un)
;Coordonnees
 LD HL,$1212
 LD (GRAF_CURS),HL
 LD B,5
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL

boucle_un_octet:
 LD HL,0
 LD (TEXT_MEM+$15),HL
 LD A,0
 LD (curseur),A
 RES 3,(IY+$05)
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 LD A,(TEXT_MEM+$14)
 INC A
 LD H,0
 LD L,A
 CALL HL_HEX
 LD A,(OP1+2)
 ROM_CALL(M_CHARPUT)
 LD A,(OP1+3)
 ROM_CALL(M_CHARPUT)
 LD HL,(GRAF_CURS)
 LD A,L
 ADD A,3
 LD L,A
 LD (GRAF_CURS),HL
 LD A,3
 CP B
 JR NZ,select_simple
 LD A,5
 LD (curseur),A
select_simple:
 LD HL,(TEXT_MEM+$14)
 INC HL
 LD (TEXT_MEM+$14),HL
 CALL affiche_chaine_dans_GRAPH_MEM
;Calcul_coordonnees
 LD HL,(GRAF_CURS)
 LD A,H
 ADD A,6
 LD H,A
 LD L,$12
 LD (GRAF_CURS),HL
 DJNZ boucle_un_octet
 LD A,(curseur_sav)
 LD (curseur),A
touches_octet_1:
 ROM_CALL(GET_KEY)

 CP G_MODE
 JP Z,retourne_debut

 CP G_DOWN
 JR NZ,p_bas_octet_1
 LD A,(TEXT_MEM+$14)
 SUB 4
 LD (TEXT_MEM+$14),A
 JP recommence_un_octet
p_bas_octet_1:

 CP G_UP
 JR NZ,p_haut_octet_1
 LD A,(TEXT_MEM+$14)
 SUB 6
 LD (TEXT_MEM+$14),A
 JP recommence_un_octet
p_haut_octet_1:

 CP G_PLUS
 JR NZ,p_plus_octet_1
 LD A,(TEXT_MEM+$14)
 ADD A,$10-5
 LD (TEXT_MEM+$14),A
 JP recommence_un_octet
p_plus_octet_1:

 CP G_MINUS
 JR NZ,p_moins_octet_1
 LD A,(TEXT_MEM+$14)
 SUB $10+5
 LD (TEXT_MEM+$14),A
 JP recommence_un_octet
p_moins_octet_1:

 CP G_ENTER
 JR Z,edit_instr_1_oct

 JR touches_octet_1

edit_instr_1_oct:
 ROM_CALL(CLEARLCD)
 LD A,(TEXT_MEM+$14)
 DEC A
 DEC A
 LD HL,(pointeur_curseur)
 LD (pointeur),HL
 LD (HL),A
 INC HL
 LD (pointeur),HL

;teste si on doit enter une valeur
 LD HL,0        ;
 LD L,A         ;
 LD BC,13       ;HL = Chaine
 CALL MUL_HL_BC ;
 LD BC,instr    ;
 ADD HL,BC      ;
 LD B,12
cherche_val_1_oct:
 INC HL
 LD A,(HL)
 CP $25 ; $25 = "%"
 JR NZ,p_entre_val_1_oct
 PUSH HL
 INC HL
 LD A,(HL)
 CP $76 ; $76 = "v"
 JR NZ,p_v_1_octet
 PRINTN(0,taper_nb_1)
 LD HL,$0603
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD A,E
 LD HL,(pointeur)
 LD (HL),A
 POP HL
 JR p_entre_val_1_oct
p_v_1_octet:
 PRINTN(0,taper_nb_2)
 LD HL,$0503
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD HL,(pointeur)
 INC HL
 LD A,E
 LD (HL),A
 CALL entre_nombre
 LD HL,(pointeur)
 LD A,E
 LD (HL),A
 POP HL
p_entre_val_1_oct:
 DJNZ cherche_val_1_oct
 JP retourne_debut

deuxoctets:
 LD A,(curseur)
 LD (curseur_sav),A
 LD A,0
 LD (affiche_adr),A
 LD HL,0
 LD (TEXT_MEM+$14),HL
 LD (TEXT_MEM+$16),HL
 LD A,$FF
 LD (TEXT_MEM+$14),A
 PRINTN(0,inst_cb_ed_dd_fd)
deux_touches:
 ROM_CALL(GET_KEY)
 CP G_MODE
 JP Z,retourne_debut
 CP G_1
 JP Z,deux_cb
 CP G_2
 JP Z,deux_ed
 CP G_3
 JP Z,deux_dd
 CP G_4
 JP Z,deux_fd
 JR deux_touches

deux_cb:
 LD HL,$FF00
 LD (TEXT_MEM+$14),HL
recommence_2_cb_octet:
;Coordonnees
 LD HL,$1212
 LD (GRAF_CURS),HL
 LD B,5
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 ROM_CALL(CLEARLCD)
 PRINTN(0,choix_instr_un)
 LD B,5
boucle_2_cb_octet:
 LD HL,0
 LD (TEXT_MEM+$16),HL
 LD A,0
 LD (curseur),A
 RES 3,(IY+$05)
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 LD A,$43
 ROM_CALL(M_CHARPUT)
 LD A,$42
 ROM_CALL(M_CHARPUT)
 LD A,(TEXT_MEM+$15)
 INC A
 LD H,0
 LD L,A
 CALL HL_HEX
 LD A,(OP1+2)
 ROM_CALL(M_CHARPUT)
 LD A,(OP1+3)
 ROM_CALL(M_CHARPUT)
 LD A,$CB
 LD (TEXT_MEM+$14),A
 LD HL,(GRAF_CURS)
 LD A,L
 ADD A,3
 LD L,A
 LD (GRAF_CURS),HL
 LD A,3
 CP B
 JR NZ,select_simple2_cb
 LD A,5
 LD (curseur),A
select_simple2_cb:
 LD HL,(TEXT_MEM+$15)
 INC HL
 LD (TEXT_MEM+$15),HL
 CALL affiche_chaine_dans_GRAPH_MEM
;Calcul_coordonnees
 LD HL,(GRAF_CURS)
 LD A,H
 ADD A,6
 LD H,A
 LD L,$12
 LD (GRAF_CURS),HL
 DJNZ boucle_2_cb_octet
 LD A,(curseur_sav)
 LD (curseur),A
touches_octet_2_cb:
 ROM_CALL(GET_KEY)

 CP G_MODE
 JP Z,retourne_debut

 CP G_DOWN
 JR NZ,p_bas_octet_2_cb
 LD A,(TEXT_MEM+$15)
 SUB 4
 LD (TEXT_MEM+$15),A
 JP recommence_2_cb_octet
p_bas_octet_2_cb:

 CP G_UP
 JR NZ,p_haut_octet_2_cb
 LD A,(TEXT_MEM+$15)
 SUB 6
 LD (TEXT_MEM+$15),A
 JP recommence_2_cb_octet
p_haut_octet_2_cb:

 CP G_PLUS
 JR NZ,p_plus_octet_2_cb
 LD A,(TEXT_MEM+$15)
 ADD A,$10-5
 LD (TEXT_MEM+$15),A
 JP recommence_2_cb_octet
p_plus_octet_2_cb:

 CP G_MINUS
 JR NZ,p_moins_octet_2_cb
 LD A,(TEXT_MEM+$15)
 SUB $10+5
 LD (TEXT_MEM+$15),A
 JP recommence_2_cb_octet
p_moins_octet_2_cb:

 CP G_ENTER
 JR Z,edit_instr_2_cb_oct

 JR touches_octet_2_cb

edit_instr_2_cb_oct:
 ROM_CALL(CLEARLCD)
 LD HL,(pointeur_curseur)
 LD (pointeur),HL
 LD A,$CB
 LD (HL),A
 INC HL
 LD A,(TEXT_MEM+$15)
 DEC A
 DEC A
 LD (HL),A
 INC HL
 LD (pointeur),HL

 JP retourne_debut

deux_ed:
 LD HL,0
 LD (TEXT_MEM+$14),HL
recommence_2_ed_octet:
;Coordonnees
 LD HL,$1212
 LD (GRAF_CURS),HL
 LD B,5
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 ROM_CALL(CLEARLCD)
 PRINTN(0,choix_instr_un)
 LD B,5
boucle_2_ed_octet:
 LD HL,0
 LD (TEXT_MEM+$16),HL
 LD A,0
 LD (curseur),A
 RES 3,(IY+$05)
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 LD A,$45
 ROM_CALL(M_CHARPUT)
 LD A,$44
 ROM_CALL(M_CHARPUT)
 LD A,(TEXT_MEM+$15)
 LD H,0
 LD L,A
 CALL HL_HEX
 LD A,(OP1+2)
 ROM_CALL(M_CHARPUT)
 LD A,(OP1+3)
 ROM_CALL(M_CHARPUT)
 LD A,$ED
 LD (TEXT_MEM+$14),A
 LD HL,(GRAF_CURS)
 LD A,L
 ADD A,3
 LD L,A
 LD (GRAF_CURS),HL
 LD A,5
 CP B
 JR NZ,select_simple2_ed
 LD A,3
 LD (curseur),A
 LD A,(TEXT_MEM+$15)
 LD (code_select),A
select_simple2_ed:
 CALL affiche_chaine_dans_GRAPH_MEM

 PUSH BC
 LD A,(TEXT_MEM+$15)
 LD B,A
 LD HL,instr_ed
cherche_prochain_code:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code
 LD DE,14
 ADD HL,DE
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 POP BC

;Calcul_coordonnees
 LD HL,(GRAF_CURS)
 LD A,H
 ADD A,6
 LD H,A
 LD L,$12
 LD (GRAF_CURS),HL
 DEC B
 LD A,B
 CP 0
 JR Z,cont0
 JP boucle_2_ed_octet
cont0:
 LD A,(curseur_sav)
 LD (curseur),A
touches_octet_2_ed:
 ROM_CALL(GET_KEY)

 CP G_MODE
 JP Z,retourne_debut

 CP G_DOWN
 JR NZ,p_bas_octet_2_ed
 LD A,(TEXT_MEM+$15)
 CP $C0
 JR Z,p_bas_octet_2_ed
 LD B,A
 LD HL,instr_ed
cherche_prochain_code1:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code1
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code1
 LD BC,56
 SBC HL,BC
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_ed_octet
p_bas_octet_2_ed:

 CP G_UP
 JR NZ,p_haut_octet_2_ed
 LD A,(TEXT_MEM+$15)
 CP $C
 JR Z,p_haut_octet_2_ed
 LD B,A
 LD HL,instr_ed
cherche_prochain_code2:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code2
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code2
 LD BC,84
 SBC HL,BC
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_ed_octet
p_haut_octet_2_ed:

 CP G_PLUS
 JR NZ,p_plus_octet_2_ed
 LD A,(TEXT_MEM+$15)
 CP $B0
 JR NC,p_bas_octet_2_ed
 LD B,A
 LD HL,instr_ed
cherche_prochain_code3:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code3
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code3
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_ed_octet
p_plus_octet_2_ed:

 CP G_MINUS
 JR NZ,p_moins_octet_2_ed
 LD A,(TEXT_MEM+$15)
 CP $19
 JR C,p_bas_octet_2_ed
 LD B,A
 LD HL,instr_ed
cherche_prochain_code4:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code4
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code4
 LD BC,140
 SBC HL,BC
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_ed_octet
p_moins_octet_2_ed:

 CP G_ENTER
 JR Z,edit_instr_2_ed_oct

 JP touches_octet_2_ed

edit_instr_2_ed_oct:
 ROM_CALL(CLEARLCD)
 LD HL,(pointeur_curseur)
 LD (pointeur),HL
 LD A,$ED
 LD (HL),A
 INC HL
 LD A,(code_select)
 LD (HL),A
 INC HL
 LD (pointeur),HL

 LD A,(code_select)
 LD B,A
 LD HL,instr_ed
cherche_prochain_code5:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code5
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code5
 LD BC,14
 SBC HL,BC ;HL = chaine

;teste si on doit enter une valeur
cherche_val_2_ed_oct:
 INC HL
 LD A,(HL)
 CP 0
 JP Z,retourne_debut
 CP $25 ; $25 = "%"
 JR NZ,cherche_val_2_ed_oct
 PUSH HL
 INC HL
 LD A,(HL)
 CP $76 ; $76 = "v"
 JR NZ,p_v_2_ed_octet
 PRINTN(0,taper_nb_1)
 LD HL,$0603
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD A,E
 LD HL,(pointeur)
 LD (HL),A
 POP HL
 JR cherche_val_2_ed_oct
p_v_2_ed_octet:
 PRINTN(0,taper_nb_2)
 LD HL,$0503
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD HL,(pointeur)
 INC HL
 LD A,E
 LD (HL),A
 CALL entre_nombre
 LD HL,(pointeur)
 LD A,E
 LD (HL),A
 POP HL
 JR cherche_val_2_ed_oct
 JP retourne_debut

deux_fd:
 LD A,1
 LD (test_fd),A
deux_dd:
 LD HL,$0900
 LD (TEXT_MEM+$14),HL
recommence_2_dd_octet:
;Coordonnees
 LD HL,$1212
 LD (GRAF_CURS),HL
 LD B,5
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 ROM_CALL(CLEARLCD)
 PRINTN(0,choix_instr_un)
 LD B,5
boucle_2_dd_octet:
 LD HL,0
 LD (TEXT_MEM+$16),HL
 LD A,0
 LD (curseur),A
 RES 3,(IY+$05)
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 LD A,(test_fd)
 CP 1
 JR Z,cont_fd
 LD A,$44
 JR c_etait_dd
cont_fd:
 LD A,$46
c_etait_dd:
 ROM_CALL(M_CHARPUT)
 LD A,$44
 ROM_CALL(M_CHARPUT)
 LD A,(TEXT_MEM+$15)
 LD H,0
 LD L,A
 CALL HL_HEX
 LD A,(OP1+2)
 ROM_CALL(M_CHARPUT)
 LD A,(OP1+3)
 ROM_CALL(M_CHARPUT)
 LD A,(test_fd)
 CP 1
 JR Z,ld_a_fd
 LD A,$DD
 JR c_etait_ld_a_dd
ld_a_fd:
 LD A,$FD
c_etait_ld_a_dd:
 LD (TEXT_MEM+$14),A
 LD HL,(GRAF_CURS)
 LD A,L
 ADD A,3
 LD L,A
 LD (GRAF_CURS),HL
 LD A,5
 CP B
 JR NZ,select_simple2_dd
 LD A,3
 LD (curseur),A
 LD A,(TEXT_MEM+$15)
 LD (code_select),A
select_simple2_dd:
 CALL affiche_chaine_dans_GRAPH_MEM

 PUSH BC
 LD A,(TEXT_MEM+$15)
 LD B,A
 LD HL,instr_dd
cherche_prochain_code_dd:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code_dd
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code_dd
 LD DE,17
 ADD HL,DE
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 POP BC

;Calcul_coordonnees
 LD HL,(GRAF_CURS)
 LD A,H
 ADD A,6
 LD H,A
 LD L,$12
 LD (GRAF_CURS),HL
 DEC B
 LD A,B
 CP 0
 JR Z,cont0_dd
 JP boucle_2_dd_octet
cont0_dd:
 LD A,(curseur_sav)
 LD (curseur),A
touches_octet_2_dd:
 ROM_CALL(GET_KEY)

 CP G_MODE
 JP Z,retourne_debut

 CP G_DOWN
 JR NZ,p_bas_octet_2_dd
 LD A,(TEXT_MEM+$15)
 CP $C0
 JR Z,p_bas_octet_2_dd
 LD B,A
 LD HL,instr_dd
cherche_prochain_code11:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code11
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code11
 LD BC,85-17
 SBC HL,BC
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_dd_octet
p_bas_octet_2_dd:

 CP G_UP
 JR NZ,p_haut_octet_2_dd
 LD A,(TEXT_MEM+$15)
 CP $C
 JR Z,p_haut_octet_2_dd
 LD B,A
 LD HL,instr_dd
cherche_prochain_code12:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code12
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code12
 LD BC,85+17
 SBC HL,BC
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_dd_octet
p_haut_octet_2_dd:

 CP G_PLUS
 JR NZ,p_plus_octet_2_dd
 LD A,(TEXT_MEM+$15)
 CP $B0
 JR NC,p_bas_octet_2_dd
 LD B,A
 LD HL,instr_dd
cherche_prochain_code13:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code13
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code13
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_dd_octet
p_plus_octet_2_dd:

 CP G_MINUS
 JR NZ,p_moins_octet_2_dd
 LD A,(TEXT_MEM+$15)
 CP $19
 JR C,p_bas_octet_2_dd
 LD B,A
 LD HL,instr_dd
cherche_prochain_code14:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code14
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code14
 LD BC,85+85
 SBC HL,BC
 LD A,(HL)
 LD (TEXT_MEM+$15),A
 JP recommence_2_dd_octet
p_moins_octet_2_dd:

 CP G_ENTER
 JR Z,edit_instr_2_dd_oct

 JP touches_octet_2_dd

edit_instr_2_dd_oct:
 ROM_CALL(CLEARLCD)
 LD HL,(pointeur_curseur)
 LD (pointeur),HL
 LD A,(test_fd)
 CP 1
 JR Z,entre_fd
 LD A,$DD
 JR c_etait_entre_fd
entre_fd:
 LD A,$FD
c_etait_entre_fd:
 LD (HL),A
 INC HL
 LD A,(code_select)
 LD (HL),A
 INC HL
 LD (pointeur),HL

 LD A,(code_select)
 LD B,A
 LD HL,instr_dd
cherche_prochain_code15:
 INC HL
 LD A,(HL)
 CP 0
 JR NZ,cherche_prochain_code15
 INC HL
 LD A,(HL)
 CP B
 JR NZ,cherche_prochain_code15
 LD BC,17
 SBC HL,BC ;HL = chaine

;teste si on doit enter une valeur
cherche_val_2_dd_oct:
 INC HL
 LD A,(HL)
 CP 0
 JP Z,retourne_debut
 CP $25 ; $25 = "%"
 JR NZ,cherche_val_2_dd_oct
 PUSH HL
 INC HL
 LD A,(HL)
 CP $76 ; $76 = "v"
 JR NZ,p_v_2_dd_octet
 PRINTN(0,taper_nb_1)
 LD HL,$0603
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD A,E
 LD HL,(pointeur)
 LD (HL),A
 POP HL
 JR cherche_val_2_dd_oct
p_v_2_dd_octet:
 PRINTN(0,taper_nb_2)
 LD HL,$0503
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD HL,(pointeur)
 INC HL
 LD A,E
 LD (HL),A
 CALL entre_nombre
 LD HL,(pointeur)
 LD A,E
 LD (HL),A
 POP HL
 JR cherche_val_2_dd_oct
 JP retourne_debut

quatreoctets:
 ROM_CALL(CLEARLCD)
 LD A,(curseur)
 LD (curseur_sav),A
 PRINTN(0,inst_dd_ou_fd)
quatreoctets_touches:
 ROM_CALL(GET_KEY)
 CP G_MODE
 JP Z,quatreoctets_quit
 CP G_1
 JP Z,quatreoctets_dd
 CP G_2
 JP Z,quatreoctets_fd
 JR quatreoctets_touches

quatreoctets_quit:
 LD A,(curseur_sav)
 LD (curseur),A
 JP retourne_debut

quatreoctets_fd:
 LD A,1
 LD (test_fd),A
 LD A,0
 LD (affiche_adr),A
 LD HL,$CBFD
 LD (TEXT_MEM+$14),HL
 JR quatreoctet_n
quatreoctets_dd:
 LD A,0
 LD (test_fd),A
 LD (affiche_adr),A
 LD HL,$CBDD
 LD (TEXT_MEM+$14),HL
quatreoctet_n:
 LD HL,0
 LD (TEXT_MEM+$16),HL
 LD A,$06
 LD (TEXT_MEM+$17),A
recommence_quatre_octet:
 ROM_CALL(CLEARLCD)
 PRINTN(0,choix_instr_un)
;Coordonnees
 LD HL,$1200
 LD (GRAF_CURS),HL
 LD B,5
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL

boucle_quatre_octet:
 LD A,0
 LD (curseur),A
 RES 3,(IY+$05)
 LD HL,TEXT_MEM+$14
 LD (pointeur),HL
 LD A,$44
 ROM_CALL(M_CHARPUT)
 LD A,$44
 ROM_CALL(M_CHARPUT)
 LD A,$43
 ROM_CALL(M_CHARPUT)
 LD A,$42
 ROM_CALL(M_CHARPUT)
 LD A,$30
 ROM_CALL(M_CHARPUT)
 LD A,$30
 ROM_CALL(M_CHARPUT)
 LD A,(TEXT_MEM+$17)
 LD H,0
 LD L,A
 CALL HL_HEX
 LD A,(OP1+2)
 ROM_CALL(M_CHARPUT)
 LD A,(OP1+3)
 ROM_CALL(M_CHARPUT)
 LD HL,(GRAF_CURS)
 LD A,L
 ADD A,3
 LD L,A
 LD (GRAF_CURS),HL
 LD A,3
 CP B
 JR NZ,select_simple_quatre
 LD A,5
 LD (curseur),A
select_simple_quatre:
 CALL affiche_chaine_dans_GRAPH_MEM
 LD A,(TEXT_MEM+$17)
 ADD A,8
 LD (TEXT_MEM+$17),A
;Calcul_coordonnees
 LD HL,(GRAF_CURS)
 LD A,H
 ADD A,6
 LD H,A
 LD L,0
 LD (GRAF_CURS),HL
 DJNZ boucle_quatre_octet
 LD A,(curseur_sav)
 LD (curseur),A
touches_octet_4:
 ROM_CALL(GET_KEY)

 CP G_MODE
 JP Z,retourne_debut

 CP G_DOWN
 JR NZ,p_bas_octet_4
 LD A,(TEXT_MEM+$17)
 SUB 32
 LD (TEXT_MEM+$17),A
 JP recommence_quatre_octet
p_bas_octet_4:

 CP G_UP
 JR NZ,p_haut_octet_4
 LD A,(TEXT_MEM+$17)
 SUB 48
 LD (TEXT_MEM+$17),A
 JP recommence_quatre_octet
p_haut_octet_4:

 CP G_PLUS
 JR NZ,p_plus_octet_4
 LD A,(TEXT_MEM+$17)
 SUB 24
 LD (TEXT_MEM+$17),A
 JP recommence_quatre_octet
p_plus_octet_4:

 CP G_MINUS
 JR NZ,p_moins_octet_4
 LD A,(TEXT_MEM+$17)
 SUB 56
 LD (TEXT_MEM+$17),A
 JP recommence_quatre_octet
p_moins_octet_4:

 CP G_ENTER
 JR Z,edit_instr_4_oct

 JR touches_octet_4

edit_instr_4_oct:
 ROM_CALL(CLEARLCD)
 LD HL,(pointeur_curseur)
 LD (pointeur),HL
 LD A,(TEXT_MEM+$14)
 LD (HL),A
 INC HL
 LD A,(TEXT_MEM+$15)
 LD (HL),A
 INC HL
 INC HL
 LD A,(TEXT_MEM+$17)
 SUB 8+8+8
 LD (HL),A

 DEC HL
 DEC HL
 DEC HL
 LD (pointeur),HL

;teste si on doit enter une valeur
 LD A,(HL)
 CP $FD
 JR Z,instr_4_octets_fd_4
 JR instr_4_octets_dd_4
instr_4_octets_fd_4:
 LD A,1
 LD (test_fd),A
instr_4_octets_dd_4:
 LD BC,instr_cb_dd
 INC HL
 INC HL
 LD (pointeur),HL
 INC HL
 LD A,(HL)
 PUSH BC
 LD HL,0
 LD L,A
 LD BC,6
 SBC HL,BC
 LD A,8
 CALL DIV_HL_A
 LD BC,14
 CALL MUL_HL_BC
 POP BC
 ADD HL,BC         ;HL = Chaine
 LD B,14
cherche_val_4_oct:
 INC HL
 LD A,(HL)
 CP $25 ; $25 = "%"
 JR NZ,p_entre_val_4_oct
 PRINTN(0,taper_nb_1)
 LD HL,$0603
 LD (CURSOR_POS),HL
 CALL entre_nombre
 LD A,E
 LD HL,(pointeur)
 LD (HL),A
p_entre_val_4_oct:
 DJNZ cherche_val_4_oct
 INC HL
 LD (pointeur),HL
 JP quatreoctets_quit

;D = nb de lettres tapes
;E = nombre  enregistrer
entre_nombre:
 LD DE,0
taper_nb:
 LD A,D
 CP 2
 RET Z
 ROM_CALL(GET_KEY)

 CP G_0
 JR NZ,zero
 LD C,0
 CALL place_nombre
zero:

 CP G_1
 JR NZ,un
 LD C,1
 CALL place_nombre
un:

 CP G_2
 JR NZ,deux
 LD C,2
 CALL place_nombre
deux:

 CP G_3
 JR NZ,trois
 LD C,3
 CALL place_nombre
trois:

 CP G_4
 JR NZ,quatre
 LD C,4
 CALL place_nombre
quatre:

 CP G_5
 JR NZ,cinq
 LD C,5
 CALL place_nombre
cinq:

 CP G_6
 JR NZ,six
 LD C,6
 CALL place_nombre
six:

 CP G_7
 JR NZ,sept
 LD C,7
 CALL place_nombre
sept:

 CP G_8
 JR NZ,huit
 LD C,8
 CALL place_nombre
huit:

 CP G_9
 JR NZ,neuf
 LD C,9
 CALL place_nombre
neuf:

 CP G_MATH
 JR NZ,a
 LD C,$A
 CALL place_nombre
a:

 CP G_MATRIX
 JR NZ,b
 LD C,$B
 CALL place_nombre
b:

 CP G_PRGM
 JR NZ,c
 LD C,$C
 CALL place_nombre
c:

 CP G_INVE
 JR NZ,d
 LD C,$D
 CALL place_nombre
d:

 CP G_SIN
 JR NZ,e
 LD C,$E
 CALL place_nombre
e:

 CP G_COS
 JR NZ,f
 LD C,$F
 CALL place_nombre
f:

 JP taper_nb

place_nombre:
 LD A,E
 ADD A,A
 ADD A,A
 ADD A,A
 ADD A,A
 OR C
 LD E,A
 INC D
 LD A,C
 ADD A,$30
 cp $3a
 jr c,p_sup_9
 add a,$7
p_sup_9:
 ROM_CALL(TX_CHARPUT)
 JP taper_nb


HL_HEX: ; Convertit le nombre hexadcimal contenu dans HL en chaine de caractre, HL pointera vers la chaine.
 ld a,h
 and $0f0
 rrca
 rrca
 rrca
 rrca
 add a,$30
 cp $3a
 jr c,HL_HEX0
 add a, $7
HL_HEX0:
 ld (OP1),a
 ld a,h
 and $0f
 add a,$30
 cp $3a
 jr c,HL_HEX1
 add a, $7
HL_HEX1:
 ld (OP1+1),a
 ld a,l
 and $0f0
 rrca
 rrca
 rrca
 rrca
 add a,$30
 cp $3a
 jr c,HL_HEX2
 add a, $7
HL_HEX2:
 ld (OP1+2),a
 ld a,l
 and $0f
 add a,$30
 cp $3a
 jr c,HL_HEX3
 add a, $7
HL_HEX3:
 ld (OP1+3),a
 xor a
 ld (OP1+4),a
 ld hl,OP1
 RET



affiche_adr .DB 0
pointeur .DW 0
pointeur_sav .DW 0
pointeur_TEXT_MEM .DW 0
pointeur_curseur .DW 0
test_4_octets .DB 0
premiere_valeur .DW 0
valeur_initiale .DW 0
test_fd .DB 0
curseur .DB 0
curseur_sav .DB 0
adresse_instruction .DW 0
code_select .DB 0

#ifdef  SNGdebFR
taille_instr  .DB "   Taille de    "
              .DB " l'instruction: "
              .DB "                ",0

inst_dd_ou_fd .DB "  Instruction   "
              .DB " commencant par "
              .DB "                "
              .DB "1- DDCB         "
              .DB "2- FDCB",0

inst_cb_ed_dd_fd .DB "  Instruction   "
                 .DB " commencant par "
                 .DB "                "
                 .DB "1- CB           "
                 .DB "2- ED           "
                 .DB "3- DD           "
                 .DB "4- FD",0

octet  .DB "1- octet",0
mot .DB "2- mot",0
dmot .DB "3- double-mot",0
choix_instr_un .DB "Choisissez votre  instruction",0
taper_nb_1 .DB "Tapez 2 chiffres",0
taper_nb_2 .DB "Tapez 4 chiffres",0
#else
taille_instr  .DB "   Size   of    "
              .DB "  instruction:  "
              .DB "                ",0

inst_dd_ou_fd .DB "  Instruction   "
              .DB "  begin    by   "
              .DB "                "
              .DB "1- DDCB         "
              .DB "2- FDCB",0

inst_cb_ed_dd_fd .DB "  Instruction   "
                 .DB "  begin    by   "
                 .DB "                "
                 .DB "1- CB           "
                 .DB "2- ED           "
                 .DB "3- DD           "
                 .DB "4- FD",0

octet  .DB "1- byte",0
mot .DB "2- word",0
dmot .DB "3- dword",0
choix_instr_un .DB "Choose instruction",0
taper_nb_1 .DB "Enter 2 numbers",0
taper_nb_2 .DB "Enter 4 numbers",0
#endif

#include "instruct.inc"

.end
END